moSetGetStationes = {};

function moSetGetStationes:setFirstStationTriggers(self, updateNewNames)	
	moStationes = {};
	moDefault.mapStations = 0;
	moBGA = {};
	moBGA.fill = 0;
	--moBGATrigger = {};	
	--local bga = 1;	
	for a, tipTrigger in pairs(g_currentMission.tipTriggers) do
		local stationName = getUserAttribute(tipTrigger.triggerId, "stationName");				
		local id = tipTrigger.triggerId;		
		if stationName ~= nil and tipTrigger.appearsOnPDA then			
			if tipTrigger.priceMultipliers ~= nil and tipTrigger.acceptedFillTypes ~= nil then				
				local textName = stationName;
				if g_i18n:hasText(stationName) then
					textName = g_i18n:getText(stationName);				
				end;
				if updateNewNames and moStationesNewName ~= nil and moDefault.xml ~= nil then
					local checkLeerName = stationName;
					if string.find(stationName, " ") then
						checkLeerName = string.gsub(stationName, " ", "_");
					end;
					local i=0;
					while true do
						i=i+1;
						local groupNewStationNameTag = ("MultiOverlay.newStationNames.name(%d)"):format(i);						
						local idx = getXMLInt(moDefault.xml, groupNewStationNameTag.."#id");
						if idx == nil or idx < 1 or idx > moDefault.lengthNewStationNamesMax then
							break;
						end;
						if moStationesNewName["id"..i].oldName == stationName or moStationesNewName["id"..i].oldName == checkLeerName then						
							textName = getXMLString(moDefault.xml, groupNewStationNameTag.."#newName");							
							if moDefault.regNewStationNames then
								if tipTrigger.mapHotspot.fullViewName ~= nil then tipTrigger.mapHotspot.fullViewName = textName;end;
							end;
							break;
						end;						
					end;
				end;
				local lengthName = string.len(textName);				 
				if lengthName < 4 then
					textName = "**".. textName.. "**"
					lengthName = lengthName+4				
				end;
				if lengthName < 6 then
					textName = "*".. textName.. "*"
					lengthName = lengthName+2				
				end;
				if lengthName > moDefault.lengthStationName then moDefault.lengthStationName = lengthName;end;
				moDefault.lengthStation = moDefault.lengthStation+lengthName+3;
				moDefault.mapStations = moDefault.mapStations+1;
				moStationes[stationName] = {};
				--if stationName == "BGA_Station_name" then
				--	moBGATrigger[bga] = {};					
				--	moBGATrigger[bga].bgaTrigger = tipTrigger;					
				--	bga = bga+1;
				--end;
				--if stationName ~= "BGA_Station_name" and string.find(string.lower(stationName), "bga") then
				--	moBGATrigger[bga] = {};					
				--	moBGATrigger[bga].bgaTrigger = tipTrigger;					
				--	bga = bga+1;
				--end;				
				moStationes[stationName].station = stationName;
				moStationes[stationName].stationName = textName
				moStationes[stationName].stationNameLength = lengthName+3;
				moStationes[stationName].acceptedFillTypes = "";
				moStationes[stationName].greatDemand = false;
				moStationes[stationName].greatDemandFruit = "";
				moStationes[stationName].greatDemandMultiplier = 1;
				moStationes[stationName].greatDemandDuration = 0;
				moStationes[stationName].firstLetter = 0;				
				moStationes[stationName].close = false;
				moStationes[stationName].insolvenz = false;
				moStationes[stationName].shares = {};
			end;		
		end;		
	end;	
end;

function moSetGetStationes:setStationUpdate(self, all)	
	moBGA.fill = 0;	
	if all then
		for a=1, Fillable.NUM_FILLTYPES do			
			local desc = Fillable.fillTypeIndexToDesc[a];
			if desc ~= nil and desc.name ~= "choppedStraw" and desc.name ~= "choppedMaize" and desc.name ~= "choppedRape" and desc.name ~= "choppedMaize_haulm" and desc.name ~= "choppedStraw_haulm" and desc.name ~= "choppedRape_haulm" then		
				if moFillTypes[desc.index] ~= nil then ----Anpassung an Mods made by HappyLooser----
					moFillTypes[desc.index].bestPrice = 0;
					moFillTypes[desc.index].bestPriceStation = "";
					moFillTypes[desc.index].greatDemandStation = nil;
					moFillTypes[desc.index].greatDemandStationDescName = nil;
					moFillTypes[desc.index].greatDemandMultiplier = 1;
					moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter,0);
					moFillTypes[desc.index].previousHourPrice = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice,0);
					moFillTypes[desc.index].startPricePerLiter = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].startPricePerLiter,0);
				end;
				----bestPrice Total----
				if Fillable.fillTypeIndexToDesc[a].partOfEconomy ~= nil and Fillable.fillTypeIndexToDesc[a].partOfEconomy and moFillTypes[desc.index] ~= nil or desc.name == "silage" then				
					local emptyFruit = moSetGetAmount:getNoFoundSiloAmount(a);
				end;
				----bestPrice Total----				
			end;
		end;		
	end;	
	for a, tipTrigger in pairs(g_currentMission.tipTriggers) do
		local stationName = getUserAttribute(tipTrigger.triggerId, "stationName");
		local id = tipTrigger.triggerId;
		if stationName ~= nil and tipTrigger.appearsOnPDA and moStationes[stationName] ~= nil then
			if tipTrigger.priceMultipliers ~= nil and tipTrigger.acceptedFillTypes ~= nil then				
				local fillTypes = "";
				if all then
				----Anpassung an Mods made by HappyLooser----
					for k,v in pairs(tipTrigger.acceptedFillTypes) do
						local desc = Fillable.fillTypeIntToName[k];						
						local descIndex = Fillable.fillTypeIndexToDesc[desc];
						if desc ~= nil and tipTrigger.acceptedFillTypes[k] then
							fillTypes = fillTypes.. desc.. " "
							--if descName ~= nil and moFillTypes[descName.index] ~= nil then
								--print("eintragen ".. stationName)
								--moFillTypes[desc].stationPriceMulti[stationName.. "PriceMulti"] = tipTrigger.priceMultipliers[desc];
							--end;
						end;
					end;
					moStationes[stationName].acceptedFillTypes = fillTypes;
				else
					fillTypes = moStationes[stationName].acceptedFillTypes;
				end;				
				----Anpassung an Mods made by HappyLooser----				
				local types = Utils.splitString(" ", fillTypes);
				local greatDemand = false;				
				for i, nameFruit in pairs(types) do
					local desc = Fillable.fillTypeNameToDesc[nameFruit];
					if desc ~= nil and desc.name ~= "choppedStraw" and desc.name ~= "choppedMaize" and desc.name ~= "choppedRape" and desc.name ~= "choppedMaize_haulm" and desc.name ~= "choppedStraw_haulm" and desc.name ~= "choppedRape_haulm" then						
						---best price
						local priceMulti = Utils.getNoNil(tipTrigger.priceMultipliers[desc.index], 0);						
						local checkOldPriceMulti = moFillTypes[desc.index].bestPrice;
						if priceMulti > checkOldPriceMulti then
							moFillTypes[desc.index].bestPrice = Utils.getNoNil(tipTrigger.priceMultipliers[desc.index], 0);
							moFillTypes[desc.index].bestPriceStation = moStationes[stationName].stationName;
						end;						
						---best price
						moFillTypes[desc.index].stationPriceMulti[stationName.. " PriceMulti"] = tipTrigger.priceMultipliers[desc.index];						
						moFillTypes[desc.index].pricePerLiter = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter,0);						
						moFillTypes[desc.index].previousHourPrice = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice,0);
						moFillTypes[desc.index].startPricePerLiter = Utils.getNoNil(Fillable.fillTypeIndexToDesc[desc.index].startPricePerLiter,0);						
						local demand = g_currentMission.economyManager:getCurrentGreatDemand(tipTrigger.stationName, desc.index);						
						if demand ~= nil and demand.isRunning then
							greatDemand = true;
							if not moStationes[stationName].greatDemand then
								moDefault.foundGreatDemand = moDefault.foundGreatDemand+1;
							end;
							moStationes[stationName].greatDemand = true;
							moFillTypes[desc.index].greatDemandStation = moStationes[stationName].stationName;
							moFillTypes[desc.index].greatDemandStationDescName = stationName;
							moFillTypes[desc.index].greatDemandMultiplier = demand.demandMultiplier;
							moStationes[stationName].greatDemandDuration = demand.demandDuration; ---active test, DrawWarnings														
							moStationes[stationName].greatDemandMultiplier = demand.demandMultiplier;
							local demandFruits = moStationes[stationName].greatDemandFruit;
							if string.find(demandFruits, nameFruit.. " ") == nil then
								moStationes[stationName].greatDemandFruit = moStationes[stationName].greatDemandFruit.. nameFruit.. " ";
							end;						
						end;
					end;
				end;	
				if not greatDemand then
					if moStationes[stationName].greatDemand then
						moDefault.foundGreatDemand = moDefault.foundGreatDemand-1;
					end;
					moStationes[stationName].greatDemand = false;					
					moStationes[stationName].greatDemandMultiplier = 1;
					moStationes[stationName].greatDemandDuration = 0;
					moStationes[stationName].greatDemandFruit = "";
				end;
			end;
		else
			if tipTrigger.bunkerSilo ~= nil and tipTrigger.bunkerSilo.state == 2 then
				moBGA.fill = moBGA.fill+math.ceil(tipTrigger.bunkerSilo.fillLevel);								
			end;
			if stationName ~= nil and moStationes[stationName] ~= nil and not tipTrigger.appearsOnPDA then
				moStationes[stationName].close = true; ----Anpassung an Mods made by HappyLooser----
			end;			
		end;
	end;	
end;

function moSetGetStationes:setStationMaxProPage(self)	
	local station = moDefault.mapStations/moDefault.maxStationsProPage;
	local maxSwitch = moSetGetGui:round(station+0.5);	
	if maxSwitch < 1 then maxSwitch = 1;end;
	moDefault.maxStationsSwitch = maxSwitch;
end;